package be.jeffcheasey88.peeratcode.routes.admins;

import java.util.regex.Matcher;

import org.json.simple.JSONObject;

import be.jeffcheasey88.peeratcode.framework.HttpReader;
import be.jeffcheasey88.peeratcode.framework.HttpWriter;
import be.jeffcheasey88.peeratcode.framework.Locker;
import be.jeffcheasey88.peeratcode.framework.Response;
import be.jeffcheasey88.peeratcode.framework.Route;
import be.jeffcheasey88.peeratcode.framework.User;
import be.jeffcheasey88.peeratcode.framework.Locker.Key;
import be.jeffcheasey88.peeratcode.repository.DatabaseRepository;

public class DynamicLogs implements Response{
	
	private Locker<Object> locker; //Context
	private DatabaseRepository repo;
	
	public DynamicLogs(DatabaseRepository repo, Locker<Object> locker){
		this.repo = repo;
		this.locker = locker;
	}

	@Route(path = "^/admin/logs$", needLogin = true, websocket = true)
	public void exec(Matcher matcher, User user, HttpReader reader, HttpWriter writer) throws Exception {
		//check if admin
		
		Key key = new Key();
		
		locker.init(key);
		try {
			while(!reader.isClosed()){
				Object instance = locker.getValue(key);
				JSONObject json = new JSONObject();
				writer.write(json.toJSONString());
				writer.flush();
				locker.lock(key);
			}
		}catch(Exception e){
			e.printStackTrace();
		}
		locker.remove(key);
	}

	
	
}
